<template>
    <div>
      <slot v-bind:handleSubmit="handleSubmit" v-bind:empty="empty" v-bind:reset="reset" v-bind:errors="errors"></slot>
    </div>
</template>

<script>
export default {  
  name: 'Vuemik',
  props: {
    initialValues: {
      type: Object,
      default: () => ({})
    },
    onSubmit: {
      type: Function,
      default: () => {}
    },
    validate: {
      type: Function,
      default: () => {}
    },
    validationSchema: {
      type: Function,
      default: () => {}
    },
  },
  data: function () {
    return { 
      values: JSON.parse(JSON.stringify(this.initialValues)),
      errors: [],
    }
  },
  provide: function () {
    return {
      handleChange: this.handleChange,
      values: () => this.values,
      validationSchema: this.validationSchema,
    }
  },
  methods: {
    handleChange(e) {
      this.values[e.target.name] = e.target.type === "checkbox" ? e.target.checked : e.target.value;
    },
    handleSubmit() {
      let values = JSON.parse(JSON.stringify(this.values));

      this.validationSchema.validate(values).then(() => {
        this.errors = [];
        this.onSubmit(values);
      }).catch((err) =>{
        this.errors = err.errors;
      });
    },
    reset: function () {
      this.$data.values = JSON.parse(JSON.stringify(this.initialValues))
    },
    empty: function () {
      this.$data.values = {}
    },
  }
}
</script>